# $Revision: 1.82 $, $Date: 2003/11/23 20:47:25 $
# TODO:
# - test on something more that 'hello world'
# - check/update configuration
#
Summary:	C library optimized for size
Summary(pl):	Biblioteka C zoptymalizowana na rozmiar
Name:		uClibc
Version:	0.9.21
Release:	4
Epoch:		2
License:	LGPL
Group:		Libraries
Source0:	http://uclibc.org/downloads/%{name}-%{version}.tar.bz2
# Source0-md5:	d4ecdc8350b7c481e06cff830883b8ec
Patch0:		%{name}-lfs.patch
Patch1:		%{name}-no_bogus_gai.patch
Patch2:		%{name}-targetcpu.patch
Patch3:		%{name}-awk.patch
Patch4:		%{name}-asmflags.patch
Patch5:		%{name}-newsoname.patch
Patch6:		%{name}-use-kernel-headers.patch
Patch7:		%{name}-alpha.patch
Patch8:		%{name}-gmon.patch
Patch9:		%{name}-sparc.patch
URL:		http://uclibc.org/
BuildRequires:	which
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%description
Small libc for building embedded applications.

%description -l pl
Maa libc do budowania aplikacji wbudowanych.

%package devel
Summary:	Development files for uClibc
Summary(pl):	Pliki dla programistw uClibc
Group:		Development/Libraries
Requires:	%{name} = %{epoch}:%{version}
Requires:	binutils
%requires_eq	gcc

%description devel
Small libc for building embedded applications.

%description devel -l pl
Maa libc do budowania aplikacji wbudowanych.

%package static
Summary:	Static uClibc libratries
Summary(pl):	Biblioteki statyczne uClibc
Group:		Development/Libraries
Requires:	%{name}-devel = %{epoch}:%{version}
Provides:	libc-static

%description static
Static uClibc libratries.

%description static -l pl
Biblioteki statyczne uClibc.

%prep
%setup -q
#%patch0 -p1  -- needs update
#%patch1 -p1  -- causes compilation errors
%patch2 -p1
%patch3 -p1
%patch4 -p1
%patch5 -p1
%patch6 -p1
%patch7 -p1
%patch8 -p1
%patch9 -p1

%ifarch %{ix86}
ln -sf extra/Configs/Config.i386.default Config
%endif
%ifarch sparc sparc64
cp -f extra/Configs/Config.{powerpc,sparc}.default
ln -sf extra/Configs/Config.sparc.default Config
%endif
%ifarch alpha
# it doesn't matter I guess
cp -f extra/Configs/Config.{powerpc,alpha}.default
ln -sf extra/Configs/Config.alpha.default Config
%endif
%ifarch ppc ppc64
ln -sf extra/Configs/Config.powerpc.default Config
%endif

%build
cat Config > Config.tmp

#	s/^SYSTEM_DEVEL_PREFIX *=.*$/SYSTEM_DEVEL_PREFIX=\$\(DEVEL_PREFIX\)\/usr/;
sed -e '
%ifarch alpha
	s/^HAVE_SHARED *=.*$/HAVE_SHARED=n/;
%else
	s/^HAVE_SHARED *=.*$/HAVE_SHARED=y/;
%endif
	s/^SYSTEM_DEVEL_PREFIX *=.*$/SYSTEM_DEVEL_PREFIX="\/usr"/;
	s/^DOLFS *=.*$/DOLFS=y/;
	s/^HAS_SHADOW *=.*$/HAS_SHADOW=y/;
	s/^INCLUDE_IPV6 *=.*$/INCLUDE_IPV6=y/;
	s/^DO_C99_MATH *=.*$/DO_C99_MATH=y/;
	s/.*UCLIBC_HAS_RPC.*/UCLIBC_HAS_RPC=y/' Config.tmp > Config

# note: defconfig and all must be run in separate make process because of macros
for targ in defconfig all ; do
%{__make} ${targ} \
%ifarch ppc
	TARGET_ARCH="powerpc" \
	TARGET_CPU="powerpc" \
%else
	TARGET_ARCH="%(echo %{_target_cpu} | sed -e 's/i.86\|athlon/i386/')" \
	TARGET_CPU="%{_target_cpu}" \
%endif
	KERNEL_SOURCE=%{_prefix} \
	HOSTCC=%{__cc} \
	HOSTCFLAGS="%{rpmcflags} %{rpmldflags}" \
	OPTIMIZATION="%{rpmcflags} -Os" \
	CC="%{__cc}"
done

%install
rm -rf $RPM_BUILD_ROOT
install -d $RPM_BUILD_ROOT%{_bindir}

%{__make} install \
	NATIVE_CC=%{__cc} \
	NATIVE_CFLAGS="%{rpmcflags} %{rpmldflags}" \
	TARGET_ARCH="%(echo %{_target_cpu} | sed -e 's/i.86\|athlon/i386/')" \
	TARGET_CPU="%{_target_cpu}" \
	CC="%{__cc}" \
	PREFIX=$RPM_BUILD_ROOT

%ifarch ppc
ln -sf ppc-linux-uclibc $RPM_BUILD_ROOT/usr/powerpc-linux-uclibc
%endif

# these links are *needed* (by stuff in bin/)
#for f in $RPM_BUILD_ROOT/usr/%{_target_cpu}-linux-uclibc%{_bindir}/* ; do
#	mv $f $RPM_BUILD_ROOT%{_bindir}
#	ln -sf ../../../bin/`basename $f` $f
#done

find $RPM_BUILD_ROOT/usr/%{_target_cpu}-linux-uclibc/include \
	-name CVS -o -name .cvsignore | xargs rm -rf

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(644,root,root,755)
%dir %{_prefix}/%{_target_cpu}-linux-uclibc
%dir %{_prefix}/%{_target_cpu}-linux-uclibc/lib
%ifarch %{ix86} ppc sparc sparc64
%attr(755,root,root) %{_prefix}/%{_target_cpu}-linux-uclibc/lib/ld-*
%attr(755,root,root) %{_prefix}/%{_target_cpu}-linux-uclibc/lib/lib*%{version}.so
%attr(755,root,root) %{_prefix}/%{_target_cpu}-linux-uclibc/lib/lib*.so.0
%endif
%ifarch ppc
%{_prefix}/powerpc-linux-uclibc
%endif

%files devel
%defattr(644,root,root,755)
%doc README TODO docs/threads.txt docs/uclibc.org/*.html
%attr(755,root,root) %{_bindir}/*
#%dir %{_prefix}/%{_target_cpu}-linux-uclibc/bin
#%attr(755,root,root) %{_prefix}/%{_target_cpu}-linux-uclibc/bin/*
%{_prefix}/%{_target_cpu}-linux-uclibc/usr
%{_prefix}/%{_target_cpu}-linux-uclibc/lib/crt*.o
%ifarch %{ix86} ppc sparc sparc64
%attr(755,root,root) %{_prefix}/%{_target_cpu}-linux-uclibc/lib/libc.so
%attr(755,root,root) %{_prefix}/%{_target_cpu}-linux-uclibc/lib/libcrypt.so
%attr(755,root,root) %{_prefix}/%{_target_cpu}-linux-uclibc/lib/libdl.so
%attr(755,root,root) %{_prefix}/%{_target_cpu}-linux-uclibc/lib/libm.so
%attr(755,root,root) %{_prefix}/%{_target_cpu}-linux-uclibc/lib/libresolv.so
%attr(755,root,root) %{_prefix}/%{_target_cpu}-linux-uclibc/lib/libutil.so
%endif
%{_prefix}/%{_target_cpu}-linux-uclibc/include

%files static
%defattr(644,root,root,755)
%{_prefix}/%{_target_cpu}-linux-uclibc/lib/lib*.a

%define date	%(echo `LC_ALL="C" date +"%a %b %d %Y"`)
%changelog
* %{date} PLD Team <feedback@pld-linux.org>
All persons listed below can be reached at <cvs_login>@pld-linux.org

$Log: uClibc.spec,v $
Revision 1.82  2003/11/23 20:47:25  qboosh
- added sparc patch, fixed file lists for sparc

Revision 1.81  2003/11/23 19:42:53  qboosh
- added alpha and gmon patches, fixed files on alpha (no shared yet)
- copy non-existing sparc config from ppc
- why g+s for libm??? killed
- release 4

Revision 1.80  2003/10/25 20:21:12  arekm
- rel 3

Revision 1.79  2003/09/25 09:08:33  arekm
- fix what areq broke (always use /usr/include/{asm,linux}); rel 2

Revision 1.78  2003/09/13 13:59:29  areq
- 0.9.21

Revision 1.77  2003/09/11 17:23:19  mmazur
- uClibc rel 2; libtool rel 9
- fuck fuck fuck shit fuck fuck fuck... ppc builder was broken all the time
  and I hadn't noticed. FUCK

Revision 1.76  2003/09/03 13:29:24  mmazur
- killed _with_lfs bcond cause this is ac

Revision 1.75  2003/08/26 18:19:12  malekith
- yet another try on alpha

Revision 1.74  2003/08/26 18:15:59  malekith
- second try on alpha

Revision 1.73  2003/08/26 18:13:36  malekith
- first try on alpha

Revision 1.72  2003/08/15 20:31:26  arekm
- rebuild

Revision 1.71  2003/08/15 19:47:12  arekm
- use headers from /usr/include not from /usr/src/linux

Revision 1.70  2003/08/06 18:53:24  arekm
- change soname for libpthread.so; rel 0.2

Revision 1.69  2003/07/24 15:22:27  qboosh
- added asmflags, per-arch optimizations are back

Revision 1.68  2003/07/15 17:49:16  areq
- 0.9.20
- remove {rpmcflags} from OPTIMIZATION, build with -Os

Revision 1.67  2003/06/27 13:10:48  mmazur
- mass commit; now req: name = epoch:version

Revision 1.66  2003/05/28 13:02:24  malekith
- massive attack: source-md5

Revision 1.65  2003/05/25 06:27:30  misi3k
- massive attack s/pld.org.pl/pld-linux.org/

Revision 1.64  2003/05/22 21:45:52  malekith
- release 0.4; %requires_eq gcc for devel

Revision 1.63  2003/05/22 21:13:42  malekith
- enable RPC
- release 0.3

Revision 1.62  2003/04/06 18:17:21  malekith
- added awk patch (now it builds fine for me)
- release 0.2

Revision 1.61  2003/04/02 22:44:56  qboosh
- started update to 0.9.19
- updated targetcpu patch, removed obsolete no_hardcoded_gcc, __thread patches
  and unneeded noinstalled patch

Revision 1.60  2003/03/27 21:53:05  malekith
- fix build on uClibc; release 0.2

Revision 1.59  2002/11/03 21:10:36  wolf
- CC=.. is also needed

Revision 1.58  2002/08/25 16:23:57  qboosh
- commented out lfs and no_bogus_gai patches - need check/update
- build different packages for i[356]86 (with a little help of targetcpu patch)
- noinstalled patch - don't require /usr/*-uclibc-linux/lib/crt0.o to build
- release 0.1 - please check commented patches

Revision 1.57  2002/07/16 21:51:53  kloczek
- start update to 0.9.12,
- removed outdated Makefile patch,
- enable shadow support.

Revision 1.56  2002/04/25 08:52:09  kloczek
- release 6: added Provides: libc-static in static subpackage.

Revision 1.55  2002/03/26 15:51:17  malekith
- ppc thinko fixed

Revision 1.54  2002/03/26 01:03:33  speedy
- sparc doesn't have ld.so

Revision 1.53  2002/03/18 18:34:32  malekith
- workaround for uClibc thinking ppc is called powerpc :)

Revision 1.52  2002/03/18 18:12:33  malekith
- br: which

Revision 1.51  2002/03/18 09:34:41  malekith
- rel 5
- updates lfs patch again

Revision 1.50  2002/03/15 14:40:22  malekith
- new version of lfs patch (always export {,f}open64 syscalls)
- added no_hardcoded_gcc patch -- allows build with itself
- rel 4

Revision 1.49  2002/03/08 15:13:19  malekith
- DO_C99_MATH = true (rint for iproute2)
- rel 3, stbr

Revision 1.48  2002/03/04 11:03:47  misiek
- now it builds on powerpc

Revision 1.47  2002/02/24 00:21:47  filon
- fixed inserted rubbish

Revision 1.46  2002/02/23 23:11:26  filon
- fix install section, tell make what TARGET_ARCH is
- release 2

Revision 1.45  2002/02/22 23:29:49  kloczek
- removed all Group fields translations (oure rpm now can handle translating
  Group field using gettext).

Revision 1.44  2002/02/05 18:14:40  kloczek
- typo.

Revision 1.43  2002/02/05 15:39:31  kloczek
- fixes for sparc: shared libraries are now builded but ld.so still not :(

Revision 1.42  2002/02/05 09:34:18  kloczek
- updated to 0.9.9 (new feactures and bugfixes),
- removed obsoleted setfsuid patch.

Revision 1.41  2002/02/02 03:22:37  kloczek
- release 5.

Revision 1.40  2002/02/02 02:20:29  misiek
- missing defattr for static subpackage

Revision 1.39  2002/01/23 16:14:53  malekith
- no_bogus_gai patch added (fixes openssh compilation)

Revision 1.38  2002/01/22 17:55:49  malekith
- more lfs fixes (new version of patch), finally builds

Revision 1.37  2002/01/22 14:26:52  malekith
- fixed lfs bcond

Revision 1.36  2002/01/22 12:49:59  malekith
- rel 4
- with lfs bcond added
- added patch to workaround uclibc bugs in lfs

Revision 1.35  2002/01/21 17:26:53  malekith
- rel 3
- added -Os to cflags
- added links in /usr/*-uclibc/usr/bin

Revision 1.34  2002/01/18 02:15:14  kloczek
perl -pi -e "s/pld-list\@pld.org.pl/feedback\@pld.org.pl/"

Revision 1.33  2002/01/05 16:51:51  kloczek
- release 2.

Revision 1.32  2002/01/04 16:40:38  malekith
- don't create /usr/bin/bin

Revision 1.31  2002/01/04 16:31:20  malekith
- s/perl/sed
- include .html docs

Revision 1.30  2002/01/03 21:51:31  kloczek
- enable ipv6 support.

Revision 1.29  2002/01/03 21:34:45  kloczek
- fix in %build,
- added gcc and binutils to Requires rules for devel subpackage.

Revision 1.28  2002/01/03 21:21:47  kloczek
- added Makefile patch which allow build uClibc from account with gid!=uid.

Revision 1.27  2002/01/03 21:10:17  kloczek
- updated to 0.9.8 (Epoch: 1),
- Added Souce url and updated URL,
- package completly reorganized.

Revision 1.26  2001/12/19 13:58:18  qboosh
- cosmetics, pl translations

Revision 1.25  2001/10/05 07:55:43  kloczek
- release 8,
- spec adapterized.

Revision 1.24  2001/10/04 11:22:58  misiek
- more arch fixes

Revision 1.23  2001/10/04 11:05:21  misiek
- this package must be arch independent

Revision 1.22  2001/08/30 22:55:51  filon
- updated to 20010826
- removed ipv6 patch, already in sources
- it builds again

Revision 1.21  2001/08/19 20:24:29  saq
- using %%_kernelsrcdir
- WARNING: doesn't build

Revision 1.20  2001/06/20 10:37:23  malekith
- new version of ipv6 patch

Revision 1.19  2001/06/19 10:27:01  malekith
- added v6 resolver patch
- rel 6

Revision 1.18  2001/06/16 10:57:38  klakier
- rel 5

Revision 1.17  2001/06/16 10:57:13  klakier
- added forgotten libdl.a
- fixed perms on libs

Revision 1.16  2001/06/10 14:26:10  kloczek
- cosmetics.

Revision 1.15  2001/06/08 15:01:39  wiget
linux-devel-BOOT is dead

Revision 1.14  2001/05/22 22:51:06  klakier
- added -m386 for BOOT

Revision 1.13  2001/05/21 19:00:44  klakier
- rel 3
- enabled rpc

Revision 1.12  2001/05/21 18:33:19  klakier
- ver 20010521

Revision 1.11  2001/05/16 14:52:33  klakier
- remove CVS dirs

Revision 1.10  2001/05/16 14:39:54  klakier
- I hate symlinks, wrrrr

Revision 1.9  2001/05/16 14:02:28  klakier
- rel 2

Revision 1.8  2001/05/16 13:59:47  klakier
- cp -pr seems to cause portability problems

Revision 1.7  2001/05/16 09:21:38  malekith
- added setfsuid patch

Revision 1.6  2001/04/19 05:18:25  kloczek
- only adapterized.

Revision 1.5  2001/04/15 13:30:07  klakier
- BuildRequires linux-devel-BOOT

Revision 1.4  2001/04/13 12:55:59  klakier
- forgot to add crt0.o to files

Revision 1.3  2001/04/13 12:40:39  klakier
- fixed requires

Revision 1.2  2001/04/13 12:28:39  klakier
- devel -> devel-BOOT

Revision 1.1  2001/04/13 12:27:23  klakier
- TODO main package ie empty (I only need -BOOT)
